#!/usr/bin/env python
# Code to record Hall Detector events and convert into flow rate
# by T.G. Cleveland 
# Base Code from : https://raspberrypi.stackexchange.com/questions/34480
#
# Tested (no sensor) 6 FEB 2019 - exit keyboard OK
#                               - syntax check OK
#
#                    5 JUN 2019 - modify for fixed run length
#                               - fixed run length OK
#                               - modify for multiple sensors
#
#                   11 MAR 2022 - refactor to append to an output file for
#                               - near real-time reporting
import RPi.GPIO as GPIO
import time,sys
# set sensor pin
flow_sensor_one = 23
flow_sensor_two = 24
#
# configure GPIO 
GPIO.setmode(GPIO.BCM)
GPIO.setup(flow_sensor_one, GPIO.IN, pull_up_down = GPIO.PUD_UP)
GPIO.setup(flow_sensor_two, GPIO.IN, pull_up_down = GPIO.PUD_UP)
#
# initialize counter(s)
#
global count
global count2
count = 0
count2 = 0
#
# define a counter method
#
def countPulse(channel):
   global count
   if start_counter == 1:
      count = count + 1
def countPulse2(channel):
   global count2
   if start_counter2 == 1:
      count2 = count2 + 1
#   now = time.strftime("%c") # capture actual time as center of sampling interval
#   print count
#   flow = count / (60.0 * 7.5) # force to float 
#   print(now + ' ' + str(count) + ' ' + str(flow))
#   print(now)
#
# 
GPIO.add_event_detect(flow_sensor_one, GPIO.FALLING, callback=countPulse)
GPIO.add_event_detect(flow_sensor_two, GPIO.FALLING, callback=countPulse2)
# Read meter specifications file

Afile = open("meterspecs.txt","r") # open meterspecs.txt connection
stationID = Afile.readline()
sensorID = Afile.readline()
howmany2wait = int(Afile.readline())
howmany2read = int(Afile.readline())
meterconstant = float(Afile.readline())
meterconstant2 = float(Afile.readline())
filename = Afile.readline().rstrip('\n')
Afile.close() # disconnect the specifications file
accCount = 0
accCount2 = 0
howmanyRread = 0
# set up header for the output
print('filenme',filename)
print('# Flowmeter Recording System ')
print('# ' + stationID),
print('# ' + sensorID),
print('# Sampling Interval Duration (seconds) ' + str(howmany2wait))
print('# Sampling Interval Count (Count * Duration = Elaped Time) ' + str(howmany2read))
print('# Events is number of counted pulses for a sampling interval')
print('# Volume is computed volume in liters for a sampling interval')
print('# 1 and 2 are the two sampling channels; Pin 16 & 18 (GPIO 23 & 24)')
print('DateTime' + ', Events1' + ', Events2 ' + ', Volume1 ' + ', Volume2 ')
#externalfile=open(filename,'a') # output file to append to
# run the datalogger for howmany2read minutes
while True:
   try:
      if howmanyRread >= howmany2read :
         print '\ntime to die!'
         print(' Total Events1 = ' + str(accCount) + ' Total Events2 = ' + str(accCount2))
         print(' Total Volume1 = ' + str(meterconstant*accCount) + ' Total Volume2 = ' + str(meterconstant2*accCount2))
         enow = time.strftime("%a %b %d %Y") # capture system time
         externalfile=open(filename,'a') # output file to append to
         externalfile.write('#Totals ' + enow + ' Events1 = ' + str(accCount) + ' Events2 = ' + str(accCount2) + '\n')
         externalfile.write('#Totals ' + enow + ' Volume1 = ' + str(meterconstant*accCount) + ' Volume2 = ' + str(meterconstant2*accCount2) + '\n')
         externalfile.close()
	 GPIO.cleanup()
         sys.exit()
      howmanyRread = howmanyRread + 1
      start_counter = 1
      start_counter2 = 1
      time.sleep(howmany2wait)
      start_counter = 0
      start_counter2 = 0
#flow = (count * 60 * 2.25 / 1000)
      flow  = (count *  meterconstant  )
      flow2 = (count2 * meterconstant2 )
      now = time.strftime("%c") # capture system time
      print(now + ' , ' + str(count) + ' , ' + str(count2) + ' , ' + str(flow) + ' , ' + str(flow2))
      externalfile=open(filename,'a') # output file to append to
      externalfile.write(now + ' , ' + str(count) + ' , ' + str(count2) + ' , ' + str(flow) + ' , ' + str(flow2) + '\n')
      externalfile.close()      
      accCount = accCount + count
      accCount2 = accCount2 + count2
      count = 0
      count2 = 0
      time.sleep(1)
   except KeyboardInterrupt:
      print '\ncaught keyboard interrupt!, bye'
      print(' Total Events1 = ' + str(accCount) + ' Total Events2 = ' + str(accCount2))
      print(' Total Volume1 = ' + str(meterconstant*accCount) + ' Total Volume2 = ' + str(meterconstant2*accCount2))
      externalfile.close()     
      GPIO.cleanup()
      sys.exit()

 
